<html>
<header>
<title> Aggiorna il database php-residence </title>
</header>
<body bgcolor=#ffffff>

<?php

#################################################################################
#    PHP-RESIDENCE
#    Copyright (C) 2001-2002 by Marco Maria Francesco De Santis (marcods@gmx.net)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##################################################################################

$pag = "aggiorna.php";

$vecchio = is_file("datipermanenti/connessione_db.inc");
if ($vecchio) { include ("datipermanenti/connessione_db.inc"); }
else { include ("dati/connessione_db.php"); }

include ("includes/funzioni.php");


$versione_corrente = @pg_exec("select * from versioni where idversioni = 1");

#pg_exec("begin");
#pg_exec("lock table anni");
$anni = pg_exec("select * from anni order by idanni");
$num_anni = pg_numrows($anni);
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_mostra = pg_result($anni,$num1,idanni);
$tableprenota = prenota. $anno_mostra;
pg_exec("lock table $tableprenota");
} # fine for $num1


if (!$versione_corrente) {
pg_exec("create table versioni (idversioni integer primary key, num_versione float4)");
pg_exec("lock table versioni");
pg_exec("insert into versioni (idversioni, num_versione) values (1, '0.1')");
$versione_corrente = "0.1";
} # fine if (!$versione_corrente)
else {
pg_exec("lock table versioni");
$versione_corrente = pg_exec("select * from versioni where idversioni = 1");
$versione_corrente = pg_result($versione_corrente,0,num_versione);
} # fine else if (!$versione_corrente)

if ($versione_corrente < "0.12") {
$aggiornato = "SI";
} # fine if ($versione_corrente < "0.12")

# c' scitto 0.19 ma in realt  la 0.2
if ($versione_corrente < "0.19") {
$aggiornato = "SI";
pg_exec("lock table appartamenti");
pg_exec("alter table appartamenti add column commento text");
rename("datipermanenti/connessione_db.inc","datipermanenti/connessione_db.php");
rename("datipermanenti/selectappartamenti.inc","datipermanenti/selectappartamenti.php");
$anni = pg_exec("select * from anni order by idanni");
$num_anni = pg_numrows($anni);
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_cambia = pg_result($anni,$num1,idanni);
rename("$anno_cambia/selectperiodi.inc","$anno_cambia/selectperiodi.php");
} # fine for $num1
pg_exec("insert into versioni (idversioni, num_versione) values (2, '100')");
$fileaperto = fopen("datipermanenti/lingua.php","a+");
fwrite($fileaperto,"<?php
\$lingua = \"ita\";
?>");
fclose($fileaperto);
pg_exec("alter table anni add column tipo_periodi text");
$anni = pg_exec("select * from anni order by idanni");
pg_exec("update anni set tipo_periodi = 's'");
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_mostra = pg_result($anni,$num1,idanni);
$tableprenota = prenota. $anno_mostra;
pg_exec("alter table $tableprenota add column conferma varchar(4)");
$tableregole = regole. $anno_mostra;
pg_exec("lock table $tableregole");
pg_exec("alter table $tableregole add column tariffa_per_app text");
pg_exec("alter table $tableregole add column motivazione text");
$tablesoldi = soldi. $anno_mostra;
pg_exec("create table $tablesoldi (idsoldi serial, motivazione text, saldo_prenota float8, saldo_cassa float8, soldi_prima float8, data_inserimento datetime)");
pg_exec("lock table $tablesoldi");
pg_exec("insert into $tablesoldi (motivazione,soldi_prima) values ('soldi_prenotazioni_cancellate','0')");
} # fine for $num1
pg_exec("create table personalizza (idpersonalizza text primary key, valpersonalizza text, valpersonalizza_num integer)");
pg_exec("lock table personalizza");
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza) values ('col_tab_tutte_prenota','ca#@&pa#@&ap#@&pe#@&co')");
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza) values ('valuta','Euro')");
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza) values ('stile_soldi','europa')");
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza) values ('costi_agg_in_tab_prenota','')");
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza_num) values ('num_linee_tab2_prenota','30')");
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza) values ('nomi_contratti','')");
# cambio idappartamenti da integer a text in appartamenti, $tableprenota e $tableregole
pg_exec("alter table appartamenti rename to appart");
pg_exec("drop index appartamenti_pkey");
pg_exec("alter table appart rename column idappartamenti to idappart");
pg_exec("alter table appart add column idappartamenti text");
$appartamenti = pg_exec("select * from appart");
$num_appartamenti = pg_numrows($appartamenti);
for ($num1 = 0 ; $num1 < $num_appartamenti ; $num1 = $num1 + 1) {
$idapp = pg_result($appartamenti,$num1,idappart);
pg_exec("update appart set idappartamenti = '$idapp' where idappart = '$idapp'");
} # fine for $num1
pg_exec("create table appartamenti ( idappartamenti text primary key, numpiano text, maxoccupanti integer, numcasa text, app_vicini text, priorita integer, commento text )");
pg_exec("insert into appartamenti select idappartamenti,numpiano,maxoccupanti,numcasa,app_vicini,priorita,commento from appart");
pg_exec("drop table appart");
$anni = pg_exec("select * from anni order by idanni");
$num_anni = pg_numrows($anni);
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_cambia = pg_result($anni,$num1,idanni);
$tableprenota = prenota . $anno_cambia;
$tableprenota_temp = pren . $anno_cambia;
pg_exec("alter table $tableprenota rename to $tableprenota_temp");
pg_exec("drop index $tableprenota"."_pkey");
pg_exec("alter table $tableprenota_temp rename column idappartamenti to idappart");
pg_exec("alter table $tableprenota_temp add column idappartamenti text");
pg_exec("alter table $tableprenota_temp rename column sconto to scon");
pg_exec("alter table $tableprenota_temp add column sconto float8");
pg_exec("alter table $tableprenota_temp rename column tariffa_tot to tariffa_t");
pg_exec("alter table $tableprenota_temp add column tariffa_tot float8");
pg_exec("alter table $tableprenota_temp rename column caparra to capar");
pg_exec("alter table $tableprenota_temp add column caparra float8");
pg_exec("alter table $tableprenota_temp rename column pagato to paga");
pg_exec("alter table $tableprenota_temp add column pagato float8");
$prenotazioni = pg_exec("select * from $tableprenota_temp");
$num_prenotazioni = pg_numrows($prenotazioni);
for ($num2 = 0 ; $num2 < $num_prenotazioni ; $num2 = $num2 + 1) {
$idprenota = pg_result($prenotazioni,$num2,idprenota);
$idapp = pg_result($prenotazioni,$num2,idappart);
$scon = pg_result($prenotazioni,$num2,scon);
$tariffa_t = pg_result($prenotazioni,$num2,tariffa_t);
$capar = pg_result($prenotazioni,$num2,capar);
$paga = pg_result($prenotazioni,$num2,paga);
pg_exec("update $tableprenota_temp set idappartamenti = '$idapp' where idprenota = '$idprenota'");
pg_exec("update $tableprenota_temp set sconto = '$scon' where idprenota = '$idprenota'");
pg_exec("update $tableprenota_temp set tariffa_tot = '$tariffa_t' where idprenota = '$idprenota'");
pg_exec("update $tableprenota_temp set caparra = '$capar' where idprenota = '$idprenota'");
pg_exec("update $tableprenota_temp set pagato = '$paga' where idprenota = '$idprenota'");
} # fine for $num2
pg_exec("create table $tableprenota (idprenota integer primary key, idclienti integer, idappartamenti text, iddatainizio integer, iddatafine integer, assegnazioneapp varchar(4), app_assegnabili text, num_persone integer, idprenota_compagna text, tariffa text, costiaggiuntivi text, sconto float8, tariffa_tot float8, caparra float8, pagato float8, commento text, conferma varchar(4), datainserimento datetime, hostinserimento varchar(50), data_modifica datetime )");
pg_exec("insert into $tableprenota select idprenota,idclienti,idappartamenti,iddatainizio,iddatafine,assegnazioneapp,app_assegnabili,num_persone,idprenota_compagna,tariffa,costiaggiuntivi,sconto,tariffa_tot,caparra,pagato,commento,conferma,datainserimento,hostinserimento,data_modifica from $tableprenota_temp");
pg_exec("drop table $tableprenota_temp");
$tableregole = regole . $anno_cambia;
$tableregole_temp = reg . $anno_cambia;
pg_exec("alter table $tableregole rename to $tableregole_temp");
pg_exec("alter table $tableregole_temp rename column app_agenzia to app_ag");
pg_exec("alter table $tableregole_temp add column app_agenzia text");
$regole = pg_exec("select * from $tableregole_temp");
$num_regole = pg_numrows($regole);
for ($num2 = 0 ; $num2 < $num_regole ; $num2 = $num2 + 1) {
$idregole = pg_result($regole,$num2,idregole);
$app_ag = pg_result($regole,$num2,app_ag);
pg_exec("update $tableregole_temp set app_agenzia = '$app_ag' where idregole = '$idregole'");
} # fine for $num2
pg_exec("create table $tableregole (idregole integer, app_agenzia text, tariffa_per_app text, iddatainizio integer, iddatafine integer, motivazione text)");
pg_exec("insert into $tableregole select idregole,app_agenzia,tariffa_per_app,iddatainizio,iddatafine,motivazione from $tableregole_temp");
pg_exec("drop table $tableregole_temp");
$tablenometariffe = ntariffe . $anno_cambia;
$tablenometariffe_temp = ntarif . $anno_cambia;
pg_exec("alter table $tablenometariffe rename to $tablenometariffe_temp ");
pg_exec("alter table $tablenometariffe_temp rename column costosettimanale to costosett");
pg_exec("alter table $tablenometariffe_temp add column costosettimanale float8");
pg_exec("alter table $tablenometariffe_temp rename column costofinale to costofin");
pg_exec("alter table $tablenometariffe_temp add column costofinale float8");
pg_exec("alter table $tablenometariffe_temp rename column costop_arrotond to costop_arr");
pg_exec("alter table $tablenometariffe_temp add column costop_arrotond float8");
pg_exec("alter table $tablenometariffe_temp rename column caparra_arrotond to caparra_arr");
pg_exec("alter table $tablenometariffe_temp add column caparra_arrotond float8");
$nomitariffe = pg_exec("select * from $tablenometariffe_temp");
$num_nomitariffe = pg_numrows($nomitariffe);
for ($num2 = 0 ; $num2 < $num_nomitariffe ; $num2 = $num2 + 1) {
$idntariffe = pg_result($nomitariffe,$num2,idntariffe);
$costosett = pg_result($nomitariffe,$num2,costosett);
$costofin = pg_result($nomitariffe,$num2,costofin);
$costop_arr = pg_result($nomitariffe,$num2,costop_arr);
$caparra_arr = pg_result($nomitariffe,$num2,caparra_arr);
pg_exec("update $tablenometariffe_temp set costosettimanale = '$costosett' where idntariffe = '$idntariffe'");
pg_exec("update $tablenometariffe_temp set costofinale = '$costofin' where idntariffe = '$idntariffe'");
pg_exec("update $tablenometariffe_temp set costop_arrotond = '$costop_arr' where idntariffe = '$idntariffe'");
pg_exec("update $tablenometariffe_temp set caparra_arrotond = '$caparra_arr' where idntariffe = '$idntariffe'");
} # fine for $num2
pg_exec("create table $tablenometariffe (idntariffe integer, tariffa1 varchar(40), tariffa2 varchar(40), tariffa3 varchar(40), tariffa4 varchar(40), tariffa5 varchar(40), tariffa6 varchar(40), tariffa7 varchar(40), tariffa8 varchar(40), tariffa9 varchar(40), tariffa10 varchar(40), costosettimanale float8, costofinale float8, costopercentuale integer, costop_arrotond float8, regole varchar(40), caparra_percent integer, caparra_arrotond float8 )");
pg_exec("insert into $tablenometariffe select idntariffe,tariffa1,tariffa2,tariffa3,tariffa4,tariffa5,tariffa6,tariffa7,tariffa8,tariffa9,tariffa10,costosettimanale,costofinale,costopercentuale,costop_arrotond,regole,caparra_percent,caparra_arrotond from $tablenometariffe_temp");
pg_exec("drop table $tablenometariffe_temp");
$tableperiodi = periodi . $anno_cambia;
$tableperiodi_temp = perio . $anno_cambia;
pg_exec("drop index $tableperiodi"."_pkey");
pg_exec("alter table $tableperiodi rename to $tableperiodi_temp ");
pg_exec("alter table $tableperiodi_temp rename column tariffa1 to tari1");
pg_exec("alter table $tableperiodi_temp add column tariffa1 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa2 to tari2");
pg_exec("alter table $tableperiodi_temp add column tariffa2 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa3 to tari3");
pg_exec("alter table $tableperiodi_temp add column tariffa3 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa4 to tari4");
pg_exec("alter table $tableperiodi_temp add column tariffa4 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa5 to tari5");
pg_exec("alter table $tableperiodi_temp add column tariffa5 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa6 to tari6");
pg_exec("alter table $tableperiodi_temp add column tariffa6 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa7 to tari7");
pg_exec("alter table $tableperiodi_temp add column tariffa7 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa8 to tari8");
pg_exec("alter table $tableperiodi_temp add column tariffa8 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa9 to tari9");
pg_exec("alter table $tableperiodi_temp add column tariffa9 float8");
pg_exec("alter table $tableperiodi_temp rename column tariffa10 to tari10");
pg_exec("alter table $tableperiodi_temp add column tariffa10 float8");
$periodi = pg_exec("select * from $tableperiodi_temp");
$num_periodi = pg_numrows($periodi);
for ($num2 = 0 ; $num2 < $num_periodi ; $num2 = $num2 + 1) {
$idperiodi = pg_result($periodi,$num2,idperiodi);
$tari1 = pg_result($periodi,$num2,tari1);
$tari2 = pg_result($periodi,$num2,tari2);
$tari3 = pg_result($periodi,$num2,tari3);
$tari4 = pg_result($periodi,$num2,tari4);
$tari5 = pg_result($periodi,$num2,tari5);
$tari6 = pg_result($periodi,$num2,tari6);
$tari7 = pg_result($periodi,$num2,tari7);
$tari8 = pg_result($periodi,$num2,tari8);
$tari9 = pg_result($periodi,$num2,tari9);
$tari10 = pg_result($periodi,$num2,tari10);
pg_exec("update $tableperiodi_temp set tariffa1 = '$tari1' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa2 = '$tari2' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa3 = '$tari3' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa4 = '$tari4' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa5 = '$tari5' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa6 = '$tari6' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa7 = '$tari7' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa8 = '$tari8' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa9 = '$tari9' where idperiodi = '$idperiodi'");
pg_exec("update $tableperiodi_temp set tariffa10 = '$tari10' where idperiodi = '$idperiodi'");
} # fine for $num2
pg_exec("create table $tableperiodi (idperiodi integer primary key, datainizio date not null, datafine date, tariffa1 float8, tariffa2 float8, tariffa3 float8, tariffa4 float8, tariffa5 float8, tariffa6 float8, tariffa7 float8, tariffa8 float8, tariffa9 float8, tariffa10 float8)");
pg_exec("insert into $tableperiodi select idperiodi,datainizio,datafine,tariffa1,tariffa2,tariffa3,tariffa4,tariffa5,tariffa6,tariffa7,tariffa8,tariffa9,tariffa10 from $tableperiodi_temp");
pg_exec("drop table $tableperiodi_temp");
$tablecosti = costi . $anno_cambia;
$tablecosti_temp = cos . $anno_cambia;
pg_exec("drop index $tablecosti"."_idcosti_key");
pg_exec("alter table $tablecosti rename to $tablecosti_temp ");
pg_exec("alter table $tablecosti_temp rename column val_costo to val_cos");
pg_exec("alter table $tablecosti_temp add column val_costo float8");
$costi = pg_exec("select * from $tablecosti_temp");
$num_costi = pg_numrows($costi);
for ($num2 = 0 ; $num2 < $num_costi ; $num2 = $num2 + 1) {
$idcosti = pg_result($costi,$num2,idcosti);
$val_cos = pg_result($costi,$num2,val_cos);
pg_exec("update $tablecosti_temp set val_costo = '$val_cos' where idcosti = '$idcosti'");
} # fine for $num2
pg_exec("create table $tablecosti (idcosti integer unique,nome_costo text, val_costo float8, persona_costo text, provenienza_costo text, tipo_costo text, datainserimento datetime, hostinserimento varchar(50))");
pg_exec("insert into $tablecosti select idcosti,nome_costo,val_costo,persona_costo,provenienza_costo,tipo_costo,datainserimento,hostinserimento from $tablecosti_temp");
pg_exec("drop table $tablecosti_temp");
} # fine for $num1
rename ("datipermanenti","dati");
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_mostra = pg_result($anni,$num1,idanni);
copy("$anno_mostra/selectperiodi.php","dati/selectperiodi$anno_mostra.php");
unlink("$anno_mostra/selectperiodi.php");
rmdir("$anno_mostra");
} # fine for $num1
} # fine if ($versione_corrente < "0.19")
else {
pg_exec("lock table appartamenti");
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_mostra = pg_result($anni,$num1,idanni);
$tableregole = regole. $anno_mostra;
pg_exec("lock table $tableregole");
$tablesoldi = soldi. $anno_mostra;
pg_exec("lock table $tablesoldi");
} # fine for $num1
pg_exec("lock table personalizza");
} # fine else if ($versione_corrente < "0.19")

if ($versione_corrente < "0.21") {
$aggiornato = "SI";
$anni = pg_exec("select * from anni order by idanni");
$num_anni = pg_numrows($anni);
for ($num1 = 0 ; $num1 < $num_anni ; $num1 = $num1 + 1) {
$anno_cambia = pg_result($anni,$num1,idanni);
copy ("dati/selectperiodi$anno_cambia.php","dati/selperiodimenu$anno_cambia.php");
} # fine for $num1
} # fine if ($versione_corrente < "0.21")

if ($versione_corrente < "0.22") {
$aggiornato = "SI";
pg_exec("insert into personalizza (idpersonalizza,valpersonalizza_num) values ('aggiunta_tronca_nomi_tab1','0')");
} # fine if ($versione_corrente < "0.22")

if ($versione_corrente < "0.23") {
$aggiornato = "SI";
} # fine if ($versione_corrente < "0.23")


if ($aggiornato == "SI") {
pg_exec("update versioni set num_versione = '0.23' where idversioni = 1");
echo "<font size=+2>".mex("Database aggiornato alla versione",$pag)." <b>0.2.3</b>!<br></font>";
} # fine if ($aggiornato == "SI")
else { echo "<font size=+2>".mex("Niente da aggiornare",$pag).".<br></font>"; }

#pg_exec("commit");

echo "<center><br><form method=\"post\" action=\"inizio.php\">
<input type=\"submit\" name=\"indietro\" value=\"".mex("Vai al men principale",$pag)."\">
</form></center>";

?>

</body>
</html>
